% Demonstration of the Deutsch Algorithm

% 20-04-2010  hannes@majer.ch


%% prepairing the elementary matrices

% pauli matrices
sigma_x = [0 1;...
           1 0];
sigma_y = [0 -i;...
           i  0];
sigma_z = [1  0;...
           0 -1];
id      = [1 0;...
           0 1];

% Hadamard
Had = [1  1;...
       1 -1]/sqrt(2);

% Controlled NOT
CNOT = [1 0 0 0;...
        0 1 0 0;...
        0 0 0 1;...
        0 0 1 0];

%% Implementation of Uf

% f(0)=0
% f(1)=0
Ufconst0 = [1 0 0 0;...
            0 1 0 0;...
            0 0 1 0;...
            0 0 0 1];

% f(0)=1
% f(1)=1
Ufconst1 = [0 1 0 0;...
            1 0 0 0;...
            0 0 0 1;...
            0 0 1 0];

% f(0)=0
% f(1)=1
Ufid     = [1 0 0 0;...
            0 1 0 0;...
            0 0 0 1;...
            0 0 1 0];
        
% f(0)=1
% f(1)=0
Ufneg    = [0 1 0 0;...
            1 0 0 0;...
            0 0 1 0;...
            0 0 0 1];

% choose one of the above gates
Uf = Ufneg;


%%

psi0 = kron([1 0]',[0 1]')

psi1 = kron(Had,id)*kron(id,Had)*psi0

psi2 = Uf*psi1

psi3 = kron(Had,id)*psi2

sz = psi3'*kron(sigma_z,id)*psi3

(1-sz)/2