% Demonstration of the Deutsch Josza Algorithm

% 21-04-2010  hannes@majer.ch


%% prepairing the elementary matrices

% pauli matrices
sigma_x = [0 1;...
           1 0];
sigma_y = [0 -i;...
           i  0];
sigma_z = [1  0;...
           0 -1];
id      = [1 0;...
           0 1];

% Hadamard
Had = [1  1;...
       1 -1]/sqrt(2);

Had2 = kron(Had,Had);
id2 = kron(id,id);

%% Implementation of Uf

%constant function

Ufconst0 = [1 0 0 0 0 0 0 0;...
            0 1 0 0 0 0 0 0;...
            0 0 1 0 0 0 0 0;...
            0 0 0 1 0 0 0 0;...
            0 0 0 0 1 0 0 0;...
            0 0 0 0 0 1 0 0;...
            0 0 0 0 0 0 1 0;...
            0 0 0 0 0 0 0 1];

Ufconst1 = [0 1 0 0 0 0 0 0;...
            1 0 0 0 0 0 0 0;...
            0 0 0 1 0 0 0 0;...
            0 0 1 0 0 0 0 0;...
            0 0 0 0 0 1 0 0;...
            0 0 0 0 1 0 0 0;...
            0 0 0 0 0 0 0 1;...
            0 0 0 0 0 0 1 0];

        
% balanced functions

% f(0,0)=1
% f(0,1)=0
% f(1,0)=0
% f(1,1)=1
Ufb1001  = [0 1 0 0 0 0 0 0;...
            1 0 0 0 0 0 0 0;...
            0 0 1 0 0 0 0 0;...
            0 0 0 1 0 0 0 0;...
            0 0 0 0 1 0 0 0;...
            0 0 0 0 0 1 0 0;...
            0 0 0 0 0 0 0 1;...
            0 0 0 0 0 0 1 0];

% f(0,0)=1
% f(0,1)=1
% f(1,0)=0
% f(1,1)=0
Ufb1100  = [0 1 0 0 0 0 0 0;...
            1 0 0 0 0 0 0 0;...
            0 0 0 1 0 0 0 0;...
            0 0 1 0 0 0 0 0;...
            0 0 0 0 1 0 0 0;...
            0 0 0 0 0 1 0 0;...
            0 0 0 0 0 0 1 0;...
            0 0 0 0 0 0 0 1];

% f(0,0)=1
% f(0,1)=1
% f(1,0)=0
% f(1,1)=1 Note: this function is neither balanced nor constant
Ufb1101  = [0 1 0 0 0 0 0 0;...
            1 0 0 0 0 0 0 0;...
            0 0 0 1 0 0 0 0;...
            0 0 1 0 0 0 0 0;...
            0 0 0 0 1 0 0 0;...
            0 0 0 0 0 1 0 0;...
            0 0 0 0 0 0 0 1;...
            0 0 0 0 0 0 1 0];

% choose one of the above gates
Uf = Ufb1001;


%%

psi0 = kron([1 0 0 0]',[0 1]')

psi1 = kron(Had2,id)*kron(id2,Had)*psi0

psi2 = Uf*psi1

psi3 = kron(Had2,id)*psi2

sz1 = psi3'*kron(kron(sigma_z,id),id)*psi3
sz2 = psi3'*kron(kron(id,sigma_z),id)*psi3

